<template>
  <div
      :class="['map', 'l2']"
      :style="{
        'width': (stepScale === 4 ? lWidth : 0) + 'px',
        'height': (stepScale === 4 ? lHeight : 0) + 'px',
        'transform': stepScale === 4 ? 'translate(' + left + 'px, ' + top + 'px) scale(' + lScale + ')' : '',
        'position': stepScale === 4 ? 'absolute' : 'static',
        'will-change': stepScale === 4 ? 'transform' : '',
        'display': visible ? '' : 'none'
      }"
  >
    <template v-for="item of els">
      <BlockBrick
          :key="Math.random(item)"
          v-if="item.type === 1"
          :x="item.x"
          :y="item.y"
          :tx="tx"
          :ty="ty"
          :l1x="l1x"
          :l1y="l1y"
          :l2x="x"
          :l2y="y"
          :step="stepScale"
          :scale="scale"
          :cw="cw"
          :ch="ch"
      />
      <BetonBrick
          :key="Math.random(item)"
          v-else-if="item.type === 2"
          :x="item.x"
          :y="item.y"
          :tx="tx"
          :ty="ty"
          :l1x="l1x"
          :l1y="l1y"
          :l2x="x"
          :l2y="y"
          :step="stepScale"
          :scale="scale"
          :cw="cw"
          :ch="ch"
      />
    </template>
  </div>
</template>

<script>
import BlockBrick from "@/components/BlockBrick";
import BetonBrick from "@/components/BetonBrick";

export default {
  name: "MapX4",
  components : { BetonBrick, BlockBrick },
  props: {
    x: Number,
    y: Number,
    width: Number,
    height: Number,
    els: Array,
    sub: Array,
    tx: Number,
    ty: Number,
    scale: Number,
    cw: Number,
    ch: Number,
    stepScale: Number,
    l1x: Number,
    l1y: Number
  },
  computed: {
    lWidth () {
      return this.width * 4;
    },
    lHeight () {
      return this.height * 4;
    },
    lScale () {
      return this.scale / 4;
    },
    left () {
      return this.x * this.scale + this.tx;
    },
    right () {
      return this.left + this.lWidth * this.scale;
    },
    top () {
      return this.y * this.scale + this.ty;
    },
    bottom () {
      return this.top + this.lHeight * this.scale;
    },
    hVisible () {
      return this.left < this.cw && this.right > 0;
    },
    vVisible () {
      return this.top < this.ch && this.bottom > 0;
    },
    visible () {
      return (this.hVisible && this.vVisible && this.stepScale === 4) || this.stepScale !== 4;
    }
  }
}
</script>

<style scoped>

</style>
